// DictionarySrchView.cpp : implementation file
//

#include "stdafx.h"
#include "Dictionary.h"

#include "DictionaryDoc.h"

//#include "ListBoxDict.h"
#include "RoundButton.h"
#include "DictionarySrchView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//extern Language	gLanguage;
/////////////////////////////////////////////////////////////////////////////
// CDictionarySrchView

IMPLEMENT_DYNCREATE(CDictionarySrchView, CFormView)

CDictionarySrchView::CDictionarySrchView()
	: CFormView(CDictionarySrchView::IDD)
{
	//{{AFX_DATA_INIT(CDictionarySrchView)
	m_Term = _T("");
	m_szEnglish = _T("");
	m_szRussian = _T("");
	//}}AFX_DATA_INIT
}

CDictionarySrchView::~CDictionarySrchView()
{
}

void CDictionarySrchView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDictionarySrchView)
	DDX_Control(pDX, IDC_INSERT, m_btnInsert);
	DDX_Control(pDX, IDC_EDIT, m_btnEdit);
	DDX_Control(pDX, IDC_DELETE, m_btnDelete);
	DDX_Control(pDX, IDC_ADD, m_btnAdd);
	DDX_Control(pDX, IDC_LIST2, m_List);
	DDX_Text(pDX, IDC_TERM, m_Term);
	DDV_MaxChars(pDX, m_Term, 50);
	DDX_Text(pDX, IDC_ENGLISH, m_szEnglish);
	DDX_Text(pDX, IDC_RUSSIAN, m_szRussian);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDictionarySrchView, CFormView)
	//{{AFX_MSG_MAP(CDictionarySrchView)
	ON_EN_CHANGE(IDC_TERM, OnChangeTerm)
	ON_EN_SETFOCUS(IDC_TERM, OnSetfocusTerm)
	ON_EN_UPDATE(IDC_TERM, OnUpdateTerm)
	ON_WM_RBUTTONUP()
	ON_EN_SETFOCUS(IDC_ENGLISH, OnSetfocusEnglish)
	ON_EN_SETFOCUS(IDC_RUSSIAN, OnSetfocusRussian)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	ON_BN_CLICKED(IDC_INSERT, OnInsert)
	ON_LBN_SELCHANGE(IDC_LIST2, OnSelchangeList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDictionarySrchView diagnostics

#ifdef _DEBUG
void CDictionarySrchView::AssertValid() const
{
	CFormView::AssertValid();
}

void CDictionarySrchView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDictionaryDoc* CDictionarySrchView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDictionaryDoc)));
	return (CDictionaryDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDictionarySrchView message handlers

void CDictionarySrchView::OnInitialUpdate() 
{
	//SetScaleToFitSize(CSize(100,100));
//	SetScrollSizes(MM_TEXT, CSize(100,100), CSize(100,100));
	CFormView::OnInitialUpdate();

	UpdateSearchBox();

	UpdateData(FALSE);
}

void CDictionarySrchView::OnChangeTerm() 
{
/*//	CDict& dict = GetDocument()->m_Dict;
	int index = 0;
	UpdateData(TRUE);

	if( m_Term == "" )
		m_List.SetCurSel( 0 );
	else 
	{
		int	first = m_Term[0];
		first = toupper( first );
		m_Term.SetAt(0,(TCHAR)first);
	}*/
		/*
	if( (index = m_List.FindString( 0, m_Term )) != LB_ERR)
		m_List.SetCurSel( index );
 */
/*	if( (index = m_List.SelectString( m_nCurIndex - 1, m_Term )) != LB_ERR)
	{
		m_nCurIndex = index;
		m_List.SetTopIndex( index );
	}
	UpdateData(FALSE);*/
}

void CDictionarySrchView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	
	if( bActivate == TRUE )
	{
/*		if( ClipboardToString( this, m_Term) )
		{
			UpdateData(FALSE);
//			OnUpdateTerm();
		}*/
//		if( GetDocument()->IsModified() )
//			OnInitialUpdate();
	}
	
	CFormView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

void CDictionarySrchView::OnSetfocusTerm() 
{
	gLanguage.SetLayout( ENGLISH_LAYOUT );
}

void CDictionarySrchView::OnUpdateTerm() 
{
	int index = 0;
	UpdateData(TRUE);

	if( (m_Term == "") | !FindString( m_Term ))
	{
		m_List.SetCurSel(0);
		m_List.SetSel( 0, FALSE );
	}
/*	else 
	{
		int	first = m_Term[0];
		first = toupper( first );
		m_Term.SetAt(0,(TCHAR)first);
	}*/
		/*
	if( (index = m_List.FindString( 0, m_Term )) != LB_ERR)
		m_List.SetCurSel( index );
 */
//	if( (index = m_List.SelectString( m_nCurIndex - 1, m_Term )) != LB_ERR)
/*	if( (index = m_List.SelectString( 0, m_Term )) != LB_ERR)
	{
		m_nCurIndex = index;
		m_List.SetTopIndex( index );
	}
*/
	//UpdateData(FALSE);
}


BOOL CDictionarySrchView::FindString( CString &szText )
{
	int index = 0;

//	m_Term = szText;
//	UpdateData(FALSE);
/*
	CString szListItem;
	BOOL	bEqual = FALSE;
	for( int i = 0; i < m_List.GetCount(); i++ )
	{
		m_List.GetTextEx( i, szListItem, IDL_ENGLISH );

		bEqual = TRUE;

		//        
		if( szListItem.GetLength() <= szText.GetLength() )
		{
			//     
			for( int n = 0; n < szListItem.GetLength(); n++ )
			{
				if( tolower(szListItem[n]) != tolower(szText[n]) )
				{
					bEqual = FALSE;
					break;
				}
			}

			if( bEqual )
			{
				m_List.SetTopIndex( i );
				m_List.SetCurSel( i );
				UpdateData(FALSE);
				return TRUE;
			}
		}
	}
*/
 
	if( (index = m_List.FindString( 0, szText)) != LB_ERR)
	{
		m_List.SetTopIndex( index );
		m_List.SetCurSel( index );
		UpdateData(FALSE);
		return TRUE;
	}
	else
		return FALSE;

	return FALSE;
}

void CDictionarySrchView::OnRButtonUp(UINT nFlags, CPoint point) 
{
/*
	CMenu m_WWMenu;

	VERIFY(m_WWMenu.LoadMenu(IDR_MENU2));
	m_WWMenu.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
											point.x, point.y, this, NULL);
*/
	
	CFormView::OnRButtonUp(nFlags, point);
}

void CDictionarySrchView::UpdateSearchBox()
{
	//   ListBox-a
	m_List.ResetContent();

	CString strKey,strValue;
	Dictionary& map = GetDocument()->m_Dict;

	//  m_List  m_Dict
	POSITION pos = map.GetStartPosition();
	while(pos) {
		map.GetNextAssoc( pos, strKey, strValue);
		m_List.AddString( strKey, strValue );
	}

	//     s
//	m_List.SetCurSel( 0 );
}

void CDictionarySrchView::OnSetfocusEnglish() 
{
	gLanguage.SetLayout( ENGLISH_LAYOUT );
}

void CDictionarySrchView::OnSetfocusRussian() 
{
	gLanguage.SetLayout( RUSSIAN_LAYOUT );
}

void CDictionarySrchView::OnAdd() 
{
	UpdateData();

	if( m_szEnglish == _T("") || m_szRussian == _T("") ) {
		AfxMessageBox(" !");
		return;
	}

	m_List.AddString(m_szEnglish, m_szRussian);
	
	GetDocument() -> m_Dict.SetAt(m_szEnglish, m_szRussian);
	GetDocument() -> SetModifiedFlag();

	m_szEnglish = _T("");
	m_szRussian = _T("");

	UpdateData(FALSE);
}

void CDictionarySrchView::OnDelete() 
{
	int sel = m_List.GetCurSel();

	if(sel != LB_ERR) {
	
		GetDocument()->m_Dict.RemoveKey( m_List.GetText(sel) );
		GetDocument()->SetModifiedFlag();

		m_List.DeleteString( sel );

		m_btnAdd.EnableWindow(TRUE);
		m_btnDelete.EnableWindow(FALSE);
		m_btnEdit.EnableWindow(FALSE);
	}
}

void CDictionarySrchView::OnEdit() 
{
	m_btnAdd.EnableWindow(FALSE);
	m_btnDelete.EnableWindow(FALSE);
	m_btnEdit.EnableWindow(FALSE);
	m_btnInsert.EnableWindow(TRUE);

	int nIndex = m_List.GetCurSel();
	if( nIndex != LB_ERR ) {
		m_szEnglish = m_List.GetText(nIndex);
		m_szRussian = GetDocument()->m_Dict[m_szEnglish];
	}
	else 
	{
		m_szEnglish = _T("");
		m_szRussian = _T("");
	}
	
	UpdateData(FALSE);
}

void CDictionarySrchView::OnInsert() 
{
	UpdateData();

	if( m_szEnglish == "" || m_szRussian == "" ) {
		AfxMessageBox(" !");
		return;
	}

	int nIndex = m_List.GetCurSel();
	if( nIndex != LB_ERR ) {
		
		GetDocument()->m_Dict.RemoveKey( m_List.GetText(nIndex) );
		m_List.DeleteString( nIndex );

		m_List.InsertString( nIndex, m_szEnglish, m_szRussian );
	
		GetDocument() -> m_Dict[m_szEnglish] = m_szRussian;
		GetDocument() -> SetModifiedFlag();

		m_szEnglish = _T("");
		m_szRussian = _T("");
		//Enable Add and Delete buttons
		m_btnAdd.EnableWindow(TRUE);
		m_btnDelete.EnableWindow(FALSE);
		m_btnEdit.EnableWindow(FALSE);
		m_btnInsert.EnableWindow(FALSE);
		UpdateData(FALSE);
	}
}

void CDictionarySrchView::OnSelchangeList() 
{
	if( m_List.GetCurSel() != LB_ERR ) {
		m_btnAdd.EnableWindow(true);
		m_btnDelete.EnableWindow(true);
		m_btnEdit.EnableWindow(true);
	}		
}

void CDictionarySrchView::OnActivateFrame(UINT nState, CFrameWnd * pFrameWnd)
{
/*	RECT rect;
	GetClientRect(&rect);

	pFrameWnd->SetWindowPos(&wndTop, rect.left, rect.top,
		rect.right, rect.bottom, SWP_NOZORDER);
*/
	CView::OnActivateFrame(nState, pFrameWnd);
}
