// DictionarySecView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDictionarySrchView form view
//#include "DictionaryDoc.h"
#include "ListBoxDict.h"

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CDictionarySrchView : public CFormView
{
protected:
	DECLARE_DYNCREATE(CDictionarySrchView)
	CDictionarySrchView();           // protected constructor used by dynamic creation

// Form Data
public:
	void UpdateSearchBox();
	BOOL FindString( CString &szText );
	CDictionaryDoc* GetDocument();

	//{{AFX_DATA(CDictionarySrchView)
	enum { IDD = IDD_DICTONARY_FORM };
	CRoundButton	m_btnInsert;
	CRoundButton	m_btnEdit;
	CRoundButton	m_btnDelete;
	CRoundButton	m_btnAdd;
	CListBoxDict	m_List;
	CString	m_Term;
	CString	m_szEnglish;
	CString	m_szRussian;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
	//CDictionaryDoc* GetDocument();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDictionarySrchView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual void OnActivateFrame( UINT nState, CFrameWnd* pFrameWnd );
	virtual ~CDictionarySrchView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CDictionarySrchView)
	afx_msg void OnChangeTerm();
	afx_msg void OnSetfocusTerm();
	afx_msg void OnUpdateTerm();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSetfocusEnglish();
	afx_msg void OnSetfocusRussian();
	afx_msg void OnAdd();
	afx_msg void OnDelete();
	afx_msg void OnEdit();
	afx_msg void OnInsert();
	afx_msg void OnSelchangeList();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CDC CompatibleDC;
	int m_nCurIndex;
};

/////////////////////////////////////////////////////////////////////////////

#ifndef _DEBUG  // debug version in DictionaryView.cpp
inline CDictionaryDoc* CDictionarySrchView::GetDocument()
   { return (CDictionaryDoc*)m_pDocument; }
#endif

