// Preferences.h : header file
//
#include "RoundButton.h"

/////////////////////////////////////////////////////////////////////////////
// CPreferences dialog
#define	DLG_NUM	3

class CPreferences : public CDialog
{
// Construction

public:
	CPreferences(CWnd* pParent = NULL);   // standard constructor
	virtual	~CPreferences(void);   // standard destructor

// Dialog Data
	//{{AFX_DATA(CPreferences)
	enum { IDD = IDD_PREFERENCES };
	CTabCtrl	m_PrefTabs;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPreferences)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CPreferences)
	afx_msg void OnSelChangeOfPrefTab(NMHDR* pNMHDR, LRESULT* pResult);
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CImageList m_imageList;
	void InsertDialogToTab(int curSel );

	int m_lastSel;
	CDialog *m_pDlg[ DLG_NUM ];
};
