//=======================================================================
// CRegistryAnalizer header file
//
////////////////////////////////////////////////////////////////////
//      s
#define DEFAULT_DOCUMENT			"DefaultDocument"
////////////////////////////////////////////////////////////////////
//    
#define WORKING_MODE_ON_WIN95_START		"SpyMode on Windows95 startup"
////////////////////////////////////////////////////////////////////
//  
#define KEYNAME_OPTIONS				"Dictionary.Document\\Options"
#define KEYNAME_WIN95_START			"Software\\Microsoft\\Windows\\CurrentVersion\\Run"
////////////////////////////////////////////////////////////////////
//   ,   
#define ADDWORD_AUTOMATICAL			"AddWordAutomatical"
#define WORD_SELECT_RANDOM			"WordSelectRandom"
////////////////////////////////////////////////////////////////////
// ,      
#define ENGLISH_FONT_NAME			"EnglishFontName"
#define ENGLISH_FONT_HEIGHT			"EnglishFontHeight"
#define ENGLISH_FONT_COLOR			"EnglishFontColor"	
const LPCSTR WORD_SPY_PATH =			"WordSpy program path";

class CRegistryAnalizer
{
//	unsigned char m_szDocName[_MAX_PATH];
	HKEY m_hDocKey, 
		 m_hWinRunKey;

	static	int m_nCopy;

public:
//	BOOL GetStudyMode( int& mode );
//	BOOL RegStudyMode( int mode );
//	int GetStudyDlgPeriod( BOOL mode );		//True - fullwindow, FALSE - unobsession
//	BOOL RegStudyDlgPeriod( BOOL mode, int period );

//	BOOL GetStartUpMode();
//	BOOL m_bUMode;
//	BOOL m_bWWMode;
	CRegistryAnalizer(void);
	~CRegistryAnalizer(void);

//	void RegDocument(CString name);
//	void UnRegDocument(void);
//	BOOL GetDocumentName(CString& name);

	void RegRunAtStartup(BOOL wwm);
	void UnRegRunAtStartup(void);

	BOOL	SetValue( const char* szKeyName, DWORD value );
	BOOL	SetValue( const char* szKeyName, CString value );

	BOOL	GetValue( const char* szKeyName, DWORD& value );
	BOOL	GetValue( const char* szKeyName, CString& value );
//	BOOL	SetValue( const char* szKeyName, DWORD value );

// Attributes
public:
	BOOL GetValue(HKEY hKey, LPCSTR szKeyName, CString &value);
	BOOL GetValue(HKEY hMainKey, LPCSTR szKeyName, LPCSTR szRegValue, CString &value);
//		BOOL m_bDocPresent;
		BOOL m_bAtStartup;
//		BOOL m_bUM;
//		BOOL m_bWWM;

private:
//	int m_iStudyMode;
	HKEY m_hOptions;
//	int m_iStudyFWDlgPeriod;	// For full-window studing
//	int m_iStudyUODlgPeriod;	// For unobsession studing
	void RegFatalError(const char* str = NULL);
	void Analyze(void);

} extern Registry;

//class CRegistryException: public CException
//{
//}
/*class CRegException
{
	CString error_name;

public:
	CRegException(const char str[])
	{
		error_name = str;
	}

	void ReportError(void);
};
*/
/////////////////////////////////////////////////////////////////////////////
//

/////////////////////////////////////////////////////////////////////////////
// Evgeny Savitsky'97
