// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "winreg.h" // for RegOpenKeyEx/RegQueryValueEx functions
#include "mbstring.h"
#include "Dictionary.h"

#include "DictionaryDoc.h"
#include "MainFrm.h"

#include "RoundButton.h"
//#include "DictionaryEditView.h"
#include "DictionarySrchView.h"
//#include "SettingsDlg.h"
//#include "Preferences.h"
#include "RegistryAnalizer.h"
//#include "Splash.h"
//#include "RememberDlg.h"
//#include "DictionarSecView.h"
#include "MainPrefDlg.h"
//#include "StudyPrefDlg.h"
#include "SettingsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//extern CMyCmdLineInfo cmdInfo;
//CTaskBarIcon TaskBarIcon;
//extern __gPreferences gPreferences;
extern CRegistryAnalizer Registry;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_GETMINMAXINFO()
	ON_COMMAND(ID_EDIT_SETTINGS, OnEditSettings)
	ON_COMMAND(ID_HELP_CONTENTS, OnHelpContents)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
//	ID_INDICATOR_SCRL,
	ID_INDICATOR_DSIZE
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
//	m_WWMenu.DestroyMenu();
/*
	if ( TaskBarIcon.m_bRun ) 
		TaskBarIcon.Remove();
*/
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{

	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

#ifdef _RUSSIAN_EDITION //   StatusBar -    
	m_wndStatusBar.SetPaneInfo( 0, ID_SEPARATOR, 
								SBPS_NORMAL | SBPS_NOBORDERS, 210);
	m_wndStatusBar.SetPaneInfo( 3, ID_INDICATOR_DSIZE, 
								SBPS_NORMAL, 130);
#endif

	//UpdateStatusBar_TermsAccount();

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);


	/////////////////////////////////////////////////////////////////////
	//    
//	HBITMAP hBmp1 = LoadBitmap( AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_SHUTDOWN));
//	HBITMAP hBmp2 = LoadBitmap( AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_CHECK));
//	m_bmp.LoadBitmap( IDB_SHUTDOWN );
	m_bmpCheck.LoadBitmap( IDB_CHECK );
	CMenu *pMMenu = GetMenu();
	
//	pMMenu->GetSubMenu(2)->SetMenuItemBitmaps( 5, MF_BYPOSITION, &m_bmp, &m_bmp );
/*	pMMenu->GetSubMenu(2)->
		SetMenuItemBitmaps( 5, MF_BYPOSITION, 
							CBitmap::FromHandle( hBmp1),
							CBitmap::FromHandle( hBmp1));
*/
	pMMenu->GetSubMenu(1)->SetMenuItemBitmaps( 0, MF_BYPOSITION, NULL, &m_bmpCheck);
	pMMenu->GetSubMenu(1)->SetMenuItemBitmaps( 1, MF_BYPOSITION, NULL, &m_bmpCheck);
/*	pMMenu->GetSubMenu(1)->
		SetMenuItemBitmaps( 2, MF_BYPOSITION, NULL, 
							CBitmap::FromHandle(hBmp2));
	pMMenu->GetSubMenu(1)->
		SetMenuItemBitmaps( 3, MF_BYPOSITION, NULL,
							CBitmap::FromHandle(hBmp2));

//	DeleteObject( hBmp1 );
//	DeleteObject( hBmp2 );
*/
	///////////////////////////////////////////////////////////////////////
	//  
	if( OpenClipboard() )
	{
		EmptyClipboard();
		CloseClipboard();
	}

	HICON hicon = (HICON) LoadImage(AfxGetResourceHandle(),
									MAKEINTRESOURCE(IDR_MAINFRAME),
									IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

///	TaskBarIcon.SetEnvironment( this, MYWM_NOTIFYICON, hicon );
	///////////////////////////////////////////////////////////
	// Add "About..." menu item to system menu.
/*	ASSERT((IDC_SHUTDOWN & 0xFFF0) == IDC_SHUTDOWN);
	ASSERT(IDC_SHUTDOWN < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_SHUTDOWN);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDC_SHUTDOWN, strAboutMenu);
	}
*/
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	//       
//	cs.cx = (int)(GetSystemMetrics(SM_CXSCREEN) / 1.9);
//	cs.cy = (int)(GetSystemMetrics(SM_CYSCREEN) / 1.25);
	cs.style &= ~WS_MAXIMIZEBOX;

	//         
//	cs.x = (GetSystemMetrics( SM_CXFULLSCREEN ) - cs.cx ) / 2;
//	cs.y = (GetSystemMetrics( SM_CYFULLSCREEN ) - cs.cy ) / 2;

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
/*	lpMMI->ptMinTrackSize.x =  
	lpMMI->ptMaxTrackSize.x = 542;//423; 

	lpMMI->ptMinTrackSize.y =  
	lpMMI->ptMaxTrackSize.y = 515; 
*/
	CFrameWnd::OnGetMinMaxInfo(lpMMI);
}


///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnEditSettings() 
{
	CString szCaption;
	if(szCaption.LoadString(IDS_PROPERTYSHEET) == NULL)
		return; //   ,  

	CPropertySheet sheet(szCaption);

	CMainPrefDlg page1;
	page1.m_psp.dwFlags |= PSP_USEHICON;
	page1.m_psp.hIcon = AfxGetApp()->LoadIcon(IDI_ICON_PROGRAM);

	CSettingsDlg page2;
	page2.m_psp.dwFlags |= PSP_USEHICON;
	page2.m_psp.hIcon = AfxGetApp()->LoadIcon(IDI_ICON_WINSTART);
	// 
	sheet.AddPage(&page1);
	sheet.AddPage(&page2);
	//sheet.AddPage(&page3);

	if(sheet.DoModal() == IDOK) //   
	{
		//  
		CView* pView = GetActiveView();
		//     RTTI
		if( pView->IsKindOf( RUNTIME_CLASS( CDictionarySrchView )))
			//  ListBox-,     
			((CDictionarySrchView*)pView)->UpdateSearchBox();
	}
}

///////////////////////////////////////////////////////////////////////////////
void CMainFrame::ActivateFrame(int nCmdShow) 
{
	UpdateStatusBar_TermsAccount();
	CFrameWnd::ActivateFrame(nCmdShow);
}

/////////////////////////////////////////////////////////////////////////////
// Evgeny Savitsky'97

void CMainFrame::OnHelpContents() 
{
	AfxGetApp()->WinHelp( 98350/*HID_HELP_CONTENTS*/ );	
}

CDictionaryDoc* CMainFrame::GetDictionaryDoc(void)
{
	return (CDictionaryDoc*) GetActiveDocument();
}

void CMainFrame::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	if( GetActiveDocument()->IsModified() )
	{	//  ,     - ...
		pCmdUI->Enable();

		UpdateStatusBar_TermsAccount();
	}
	else
		pCmdUI->Enable(FALSE); //True;
}

//////////////////////////////////////////////////////////////////////////////////
// UpdateStatusBar_TermsAccount()
void CMainFrame::UpdateStatusBar_TermsAccount()
{
	//   
	int size = ((CDictionaryDoc *)CFrameWnd::GetActiveDocument())->m_Dict.GetCount();
	CString str1;

	str1.Format(" %d ", size );
#ifdef _ENGLISH_EDITION		
	str1 += _T("term(s)");
#endif
#ifdef _RUSSIAN_EDITION
	str1 += _T("()");
#endif

	//      
	m_wndStatusBar.SetPaneText( m_wndStatusBar.CommandToIndex( 
								ID_INDICATOR_DSIZE), str1 );
}

void CDictionaryDoc::DeleteContents() 
{
	m_Dict.RemoveAll();	
	CDocument::DeleteContents();
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	
	return CFrameWnd::OnCreateClient(lpcs, pContext);
}
