// MainPrefDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
//#include "DicProperties.h"
//#include "Dictionary.h"
#include "MainPrefDlg.h"
#include "RegistryAnalizer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainPrefDlg dialog
//extern __gPreferences gPreferences;
//extern HMODULE	hModule;
extern CRegistryAnalizer Registry;


CMainPrefDlg::CMainPrefDlg(CWnd* pParent /*=NULL*/)
	: CPropertyPage(CMainPrefDlg::IDD)
{
	//     DLL-	
/*	HRSRC hRsrc = FindResource( hModule, MAKEINTRESOURCE(IDD), RT_DIALOG);

	if( hRsrc == NULL )
	{
#ifdef _ENGLISH_EDITION
		::MessageBox( NULL, "Can't find resource", "Error..", MB_OK);
#endif
#ifdef _RUSSIAN_EDITION
		::MessageBox( NULL, "  ", "Error..", MB_OK);
#endif
		return;
	}

	HGLOBAL hDlgRes = LoadResource( hModule, hRsrc );
	if( hDlgRes == NULL )
	{
#ifdef _ENGLISH_EDITION
		::MessageBox( NULL, "Can't load resource", "Error..", MB_OK);
#endif
#ifdef _RUSSIAN_EDITION
		::MessageBox( NULL, "  ", "Error..", MB_OK);
#endif
		return;
	}
	//   
	CreateIndirect( hDlgRes, pParent);
*/
	//{{AFX_DATA_INIT(CMainPrefDlg)
	m_bOpenDoc = FALSE;
	m_szDocName = _T("");
	//}}AFX_DATA_INIT

	memset(&m_logFont, 0, sizeof(m_logFont));	// Initializing m_logFont

	memset(&m_cfnt, 0, sizeof(m_cfnt));	// Initializing m_cfnt ( CHOOSEFONT )
	m_cfnt.lStructSize = sizeof( m_cfnt );
	m_cfnt.rgbColors = RGB( 255, 0, 0 );



//	HINSTANCE hOldRHandle = AfxGetResourceHandle();
//	AfxSetResourceHandle( hModule );

//	Create( IDD, pParent );
//	AfxSetResourceHandle( hOldRHandle );
}


void CMainPrefDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainPrefDlg)
	DDX_Control(pDX, IDC_USECURRENT, m_btnUseCurrent);
	DDX_Control(pDX, IDC_OPENDOC, m_btnOpenDoc);
	DDX_Check(pDX, IDC_OPENDOC, m_bOpenDoc);
	DDX_Text(pDX, IDC_DOCNAMEEDIT, m_szDocName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMainPrefDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CMainPrefDlg)
	ON_BN_CLICKED(IDC_USECURRENT, OnOpenDocument)
	ON_BN_CLICKED(IDC_ENGLISH_FONT, OnEnglishFont)
	//}}AFX_MSG_MAP
//	ON_MESSAGE( WM_SAVESETTINGS, OnSaveSettings )

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainPrefDlg message handlers

BOOL CMainPrefDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
//	m_bAutoAddWord = gPreferences.bAutoAddWord;
		if(	Registry.GetValue( DEFAULT_DOCUMENT, m_szDocName ))
		{
			if( m_szDocName != "" )
			{
				m_bOpenDoc = TRUE;

				if( m_szDocName == m_szCurrentDoc )
					m_btnUseCurrent.EnableWindow(FALSE);
			}
			else
			{
				m_bOpenDoc = FALSE;
				m_btnOpenDoc.EnableWindow(FALSE);
			}
		}
		else
			return FALSE;

//	DWORD bAutoAddWord = 0;
//	if( Registry.GetValue( ADDWORD_AUTOMATICAL, &bAutoAddWord ))
//		m_bAutoAddWord = (BOOL) bAutoAddWord;
//	Registry.GetValue( ADDWORD_AUTOMATICAL, (DWORD &) m_bAutoAddWord );

    ///////////////////////////////////////////////////////////////////////
	CString szFontName;
	if( !Registry.GetValue(ENGLISH_FONT_NAME,  szFontName))
		szFontName = "Arial";
	strcpy(m_logFont.lfFaceName, (LPCTSTR) szFontName );

	Registry.GetValue( ENGLISH_FONT_HEIGHT, (DWORD&) m_logFont.lfHeight );
	Registry.GetValue( ENGLISH_FONT_COLOR, m_cfnt.rgbColors );
	///////////////////////////////////////////////////////////////////////

	UpdateData(FALSE);	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMainPrefDlg::OnOpenDocument() 
{
	CFileDialog* pFileDialog = new CFileDialog( TRUE, NULL, "*.dic", NULL,
												" (*.dic) | *.dic ||");
	switch( pFileDialog->DoModal() )
	{
	case IDOK:
		m_szDocName = pFileDialog->GetPathName();
//		m_btnOpenDoc.EnableWindow(TRUE);
//		break;
	case IDCANCEL:
		m_btnOpenDoc.EnableWindow(TRUE);
		break;
	default:
		m_szDocName = "";
		m_btnOpenDoc.EnableWindow(FALSE);
	}
	UpdateData(false);

	delete pFileDialog;
}

void CMainPrefDlg::OnEnglishFont() 
{
	CFontDialog fntDlg( &m_logFont, CF_FORCEFONTEXIST|CF_EFFECTS|
							  CF_SCREENFONTS|CF_INITTOLOGFONTSTRUCT );

	//fntDlg.m_cf.lpLogFont = &m_logFont;
//	fntDlg.m_cf.iPointSize = m_cfnt.iPointSize;
	fntDlg.m_cf.rgbColors = m_cfnt.rgbColors;

	//fntDlg.m_cf.rgbColors = m_dwEnFntColor;
	
	if( fntDlg.DoModal() == IDOK );

	m_cfnt.iPointSize = fntDlg.GetSize();
	m_cfnt.rgbColors = fntDlg.GetColor();

//	m_dwEnFntColor = fntDlg.m_cf.rgbColors ;
}

void CMainPrefDlg::OnOK() 
{
	UpdateData(TRUE);
	//     Dictionary
	if( m_bOpenDoc )
		Registry.SetValue(DEFAULT_DOCUMENT, m_szDocName );
	else
		// or write empty string to the registry 
		Registry.SetValue(DEFAULT_DOCUMENT, "");
//	Registry.SetValue( ADDWORD_AUTOMATICAL, m_bAutoAddWord );
	//    
	Registry.SetValue( ENGLISH_FONT_NAME, CString( m_logFont.lfFaceName ));
	Registry.SetValue( ENGLISH_FONT_HEIGHT, m_logFont.lfHeight);
	Registry.SetValue( ENGLISH_FONT_COLOR, m_cfnt.rgbColors);
	
	CPropertyPage::OnOK();
}
