// SettingsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "winreg.h" // for RegOpenKeyEx/RegQueryValueEx functions
#include "resource.h"
//#include "DicProperties.h"
//#include "DicProp.h"
//#include "Dictionary.h"
#include "SettingsDlg.h"
#include "RegistryAnalizer.h"
//#include "TaskBarIcon.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CRegistryAnalizer Registry;
//extern HMODULE	hModule;
//extern CMyCmdLineInfo cmdInfo;
//extern CTaskBarIcon TaskBarIcon;
/////////////////////////////////////////////////////////////////////////////
// CSettingsDlg dialog


CSettingsDlg::CSettingsDlg(CWnd* pParent /*=NULL*/)
	: CPropertyPage(CSettingsDlg::IDD)
{
	//{{AFX_DATA_INIT(CSettingsDlg)
	m_bAtStartup = FALSE;
	//}}AFX_DATA_INIT
}


void CSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingsDlg)
	DDX_Check(pDX, IDC_ATSTART, m_bAtStartup);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingsDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CSettingsDlg)
	ON_BN_CLICKED(IDC_ATSTART, OnAtstart)
	//}}AFX_MSG_MAP
//	ON_MESSAGE( WM_SAVESETTINGS, OnSaveSettings )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsDlg message handlers
void CSettingsDlg::OnAtstart() 
{
}


BOOL CSettingsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();	
	
		//     Windows
		if( Registry.m_bAtStartup )
		{
			m_bAtStartup = TRUE;
		}
			
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CSettingsDlg::OnOK() 
{
	UpdateData(TRUE);
	//  Dictionary   Windows
	if(m_bAtStartup)
		Registry.RegRunAtStartup(FALSE);
	else
		Registry.UnRegRunAtStartup();

	CPropertyPage::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// Evgeny Savitsky'97

