// WordSpy.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "WordSpy.h"
#include "PictureButton.h"
#include "WordSpyDlg.h"
#include "..\RegistryAnalizer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//CRegistryAnalizer Registry;

/////////////////////////////////////////////////////////////////////////////
// CWordSpyApp

BEGIN_MESSAGE_MAP(CWordSpyApp, CWinApp)
	//{{AFX_MSG_MAP(CWordSpyApp)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWordSpyApp construction

CWordSpyApp::CWordSpyApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CWordSpyApp object

CWordSpyApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWordSpyApp initialization

BOOL CWordSpyApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	CWordSpyDlg dlg;
	m_pMainWnd = &dlg;

	CString name;

	if(	Registry.GetValue(DEFAULT_DOCUMENT, name))
	{
		CFile file;
		if( !file.Open( name, CFile::modeRead) ) {
			ExitInstance();
		}
		CArchive ar( &file, CArchive::load);
		dlg.m_Dict.Serialize(ar);
	}

	////////////////////////////////////////////////
	//
/*
	dlg.Create(CWordSpyDlg::IDD);

	CFile file;
	if( !file.Open( name, CFile::modeWrite) ) {
		ExitInstance();
	}
	CArchive ar( &file, CArchive::store);
	dlg.m_Dict.Serialize(ar);
*/
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		CFile file;
		if( !file.Open( name, CFile::modeWrite) ) {
			ExitInstance();
		}
		CArchive ar( &file, CArchive::store);
		dlg.m_Dict.Serialize(ar);
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}
	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

int CWordSpyApp::ExitInstance() 
{

	return CWinApp::ExitInstance();
}
